Codeforces Round #827 (Div. 4)G

Codeforces Round #827 (Div. 4)

题目大意:定义前缀和数组bi=a1 | a2 | a3 | a4 ......ai,问怎么排列a数组使b数组最大。

思路:因为求前缀数组的最大值,那么我们可以每次排序就应该把与|运算后增量大的那个数放最前面,因为int最大也就30位二进制数,那么可以直接sort排序min(30,n)次,

因为每次排序后都将确定一个数的位置,所以每次排序的范围也要改变

代码

/**
*  ┏┓   ┏┓+ +
* ┏┛┻━━━┛┻┓ + +
* ┃       ┃
* ┃   ━   ┃ ++ + + +
*  ████━████+
*  ◥██◤ ◥██◤ +
* ┃   ┻   ┃
* ┃       ┃ + +
* ┗━┓   ┏━┛
*   ┃   ┃ + + + +Code is far away from  
*   ┃   ┃ + bug with the animal protecting
*   ┃    ┗━━━┓ 神兽保佑,代码无bug 
*   ┃  	    ┣┓
*    ┃        ┏┛
*     ┗┓┓┏━┳┓┏┛ + + + +
*    ┃┫┫ ┃┫┫
*    ┗┻┛ ┗┻┛+ + + +
*/

#include<cstdio>
#include <iostream>
#include <algorithm>
#include <string.h>
#include <string>
#include <math.h>
#include<vector>
#include<queue>
#include<map>
#define ll long long 
using namespace std;

const int N=1000000+100;
int n ,m,h;
ll s[N];
int ans=0;
bool cmp(int x,int y ){
	return (x|ans)>(y|ans);
}

int main()
{
	
	int t ;
	cin>>t;
	while(t--)
	{
		cin>>n;
		for(int i =1;i<=n;i++)
		{
			cin>>s[i];
		}

		ans=0;//每次更新前缀和
		for(int i =1;i<=min(n,30);i++)
		{
			sort(s+i,s+1+n,cmp);
			ans|=s[i];
		}
		for(int i =1;i<=n;i++)cout<<s[i]<<" ";
		cout<<endl;
	}
	return 0;
}

  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值